require 'lib/scanner.rb'
require 'test/unit'

class YaparcParserTest < Test::Unit::TestCase
  def test_RootScanner
    parser = OpenEHR::ADL::Scanner::DADL::RootScanner.new
    assert_instance_of OpenEHR::ADL::Scanner::DADL::RootScanner,parser
    result = parser.parse('')
  end

  def test_V_LOCAL_TERM_CODE_REF
    parser = OpenEHR::ADL::Scanner::DADL::V_LOCAL_TERM_CODE_REF.new
    assert_instance_of OpenEHR::ADL::Scanner::DADL::V_LOCAL_TERM_CODE_REF,parser
    result = parser.parse('[en-us]')
    assert_instance_of Yaparc::Result::OK, result
  end

  def test_V_QUALIFIED_TERM_CODE_REF
    parser = OpenEHR::ADL::Scanner::DADL::V_QUALIFIED_TERM_CODE_REF.new
    assert_instance_of OpenEHR::ADL::Scanner::DADL::V_QUALIFIED_TERM_CODE_REF,parser
    result = parser.parse('[ISO_639::en]')
    assert_instance_of Yaparc::Result::OK, result
    result = parser.parse('[ISO_639::en-us]')
    assert_instance_of Yaparc::Result::OK, result
  end

  def test_V_STRING
    parser = OpenEHR::ADL::Scanner::DADL::V_STRING.new
    assert_instance_of OpenEHR::ADL::Scanner::DADL::V_STRING,parser
    result = parser.parse('"this is a string"')
    assert_instance_of Yaparc::Result::OK, result
    result = parser.parse('"en-us"')
    assert_instance_of Yaparc::Result::OK, result
  end

  def test_V_REAL
    parser = OpenEHR::ADL::Scanner::DADL::V_REAL.new
    assert_instance_of OpenEHR::ADL::Scanner::DADL::V_REAL,parser
    result = parser.parse('0.1')
    assert_instance_of Yaparc::Result::OK, result
    result = parser.parse('0.0..20000.0')
    assert_instance_of Yaparc::Result::OK, result
    assert_equal [:V_REAL, "0.0"], result.value
    assert_equal "..20000.0", result.input

  end
end
